WordMakerParser Class Referencefinal

the main class to read a WordMaker file More...

`#include <WordMakerParser.hxx>`

Inheritance diagram for WordMakerParser:

## Public Member Functions
| WordMakerParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor
| ~WordMakerParser () final
| destructor
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not)
void | parse (librevenge::RVNGTextInterface *documentInterface) final
| virtual function used to parse the input
Public Member Functions inherited from MWAWTextParser
| ~MWAWTextParser () override
| destructor
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor
int | version () const
| returns the works version
MWAWParserStatePtr | getParserState ()
| returns the parser state
MWAWHeader * | getHeader ()
| returns the header
MWAWInputStreamPtr & | getInput ()
| returns the actual input
MWAWListenerPtr | getMainListener ()
| returns the main listener
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension
double | getFormLength () const
| returns the form length
double | getFormWidth () const
| returns the form width
double | getPageLength () const
| returns the page length (form length without margin )
double | getPageWidth () const
| returns the page width (form width without margin )
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document

## Protected Member Functions
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document
bool | createZones ()
| finds the different objects zones
void | newPage ()
| adds a new page
bool | sendZone (WordMakerParserInternal::Zone const &zone)
| try to send the content of a zone
bool | sendPicture (MWAWEntry const &entry)
| try to send a picture
bool | readFont (long len, MWAWFont &font)
| try to read a font and its beginning position
bool | readFontNames (long len)
| try to read the fonts names
bool | readParagraph (long len, MWAWParagraph &para, MWAWFont &font)
| try to read a paragraph (and its default font)
bool | readPicture (long len, MWAWEmbeddedObject &object, MWAWBox2f &bdbox, int &page)
| try to read a picture (and its size)
bool | readTabulations (long len, MWAWParagraph &para)
| try to read a list of tabulations
bool | readPrintInfo (long len)
| try to read the printer information
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWTextParser (MWAWParserStatePtr const &state)
| constructor using a state
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state
void | setVersion (int vers)
| sets the document's version
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener
void | resetGraphicListener ()
| resets the listener
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener
void | resetPresentationListener ()
| resets the listener
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener
void | resetSpreadsheetListener ()
| resets the listener
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener
void | resetTextListener ()
| resets the listener
void | setAsciiName (char const *name)
| Debugging: change the default ascii file.
std::string const & | asciiName () const
| return the ascii file name

## Protected Attributes
std::shared_ptr< WordMakerParserInternal::State > | m_state
| the state

## Friends
class | WordMakerParserInternal::SubDocument

## Detailed Description

the main class to read a WordMaker file

## Constructor & Destructor Documentation

## ◆ WordMakerParser()

WordMakerParser::WordMakerParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header )

constructor

## ◆ ~WordMakerParser()

WordMakerParser::~WordMakerParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool WordMakerParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = false )
| final virtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse(), and WordMakerParserInternal::SubDocument.

## ◆ createDocument()

void WordMakerParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse(), and WordMakerParserInternal::SubDocument.

## ◆ createZones()

bool WordMakerParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse(), and WordMakerParserInternal::SubDocument.

## ◆ newPage()

void WordMakerParser::newPage | ( |  | ) |
| protected

adds a new page

Referenced by sendZone(), and WordMakerParserInternal::SubDocument.

## ◆ parse()

void WordMakerParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| final virtual

virtual function used to parse the input

Implements MWAWTextParser.

Referenced by WordMakerParserInternal::SubDocument.

## ◆ readFont()

bool WordMakerParser::readFont | ( | long | len,
|  | MWAWFont & | font )
| protected

try to read a font and its beginning position

Referenced by readParagraph(), sendZone(), and WordMakerParserInternal::SubDocument.

## ◆ readFontNames()

bool WordMakerParser::readFontNames | ( | long | len | ) |
| protected

try to read the fonts names

Referenced by createZones(), and WordMakerParserInternal::SubDocument.

## ◆ readParagraph()

bool WordMakerParser::readParagraph | ( | long | len,
|  | MWAWParagraph & | para,
|  | MWAWFont & | font )
| protected

try to read a paragraph (and its default font)

Referenced by sendZone(), and WordMakerParserInternal::SubDocument.

## ◆ readPicture()

bool WordMakerParser::readPicture | ( | long | len,
|  | MWAWEmbeddedObject & | object,
|  | MWAWBox2f & | bdbox,
|  | int & | page )
| protected

try to read a picture (and its size)

Referenced by sendPicture(), and WordMakerParserInternal::SubDocument.

## ◆ readPrintInfo()

bool WordMakerParser::readPrintInfo | ( | long | len | ) |
| protected

try to read the printer information

Referenced by createZones(), and WordMakerParserInternal::SubDocument.

## ◆ readTabulations()

bool WordMakerParser::readTabulations | ( | long | len,
|  | MWAWParagraph & | para )
| protected

try to read a list of tabulations

Referenced by sendZone(), and WordMakerParserInternal::SubDocument.

## ◆ sendPicture()

bool WordMakerParser::sendPicture | ( | MWAWEntry const & | entry | ) |
| protected

try to send a picture

Referenced by parse(), and WordMakerParserInternal::SubDocument.

## ◆ sendZone()

bool WordMakerParser::sendZone | ( | WordMakerParserInternal::Zone const & | zone | ) |
| protected

try to send the content of a zone

Referenced by parse(), and WordMakerParserInternal::SubDocument.

## Friends And Related Symbol Documentation

## ◆ WordMakerParserInternal::SubDocument

friend class WordMakerParserInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_state

std::shared_ptr<WordMakerParserInternal::State> WordMakerParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), createZones(), newPage(), parse(), sendZone(), and WordMakerParser().

The documentation for this class was generated from the following files:

- WordMakerParser.hxx
- WordMakerParser.cxx